require "calc"


# Here begins our simple main test program

# First, we'll define an expression processor that includes the operations we
# want

class MyExpressionProcessor < ExpressionProcessor

  # Let's just add all of the usual operators

include ParentheticalGrouping           # ()
include AssignmentOperator              # =
include LastResultOperator              # $
include ArithmeticOperators             # +-*/%^
include BooleanOperators                # true false and or eq ne gt lt ge le not

  # example of adding custom operators

  def AddOperators_custom

    # Just for fun, let's define a "sum" function, that can take 1 or more
    # arguments and return their sum

#    @operators << Function.new("sum", 1, nil) do |*args| 
 #       sum = 0
  #      args.each { |arg| sum += arg.value }
   #     sum
    #  end

    # Now let's show how you can use a function to access a constant, like PI

    @operators << Function.new("PI", 0, 0) { Math::PI }

  end
end

# For our example program, we'll use a Hash to store the values of Identifiers
# in the expressions

vals = Hash.new

# Now create our expression processor, passing it a code block to access
# the identifier values

ex = MyExpressionProcessor.new do |ident, newval|
  p ident
  p newval
  puts

  vals[ident] = newval if (newval)      # Store any new value passed

  if (v = vals[ident]) then             # If the identifier has been stored,
    v                                   #   return its value
  else                                  # Haven't stored this one yet
    nil                                 # return nil (just to be friendly --
                                        #  we could have thrown an exception)
  end
end

# Main I/O loop here

while gets()                            # Type something, you.
  begin
    puts(ex.eval($_))                   # Evaluate the expression and output the result
    rescue => e                         # Problem?
      puts("Error: " + e.message)       # Tell us about it
  end
end

